unit ExPageControl;

{$mode delphi}

{$ifdef I386}

{$endif I386}
{$ifdef x86_64}

{$endif x86_64}

interface

uses
  Classes, SysUtils, ComCtrls, Graphics, Controls,
  LMessages, LCLType, LCLIntf;

type

  TExTabSheet = class(TTabSheet)
  private
    { private declarations }
  protected
    procedure WMPaint(var Msg: TLMPaint); message LM_PAINT;
    procedure WMEraseBkgnd(var Message: TLMEraseBkgnd); message LM_ERASEBKGND;
  public
    { public declarations }
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  end;

  //----------------------------------------------------------------------------

  TExPageControl = class(TPageControl)
  private
    { private declarations }
  protected
    procedure   WMPaint(var Msg: TLMPaint); message LM_PAINT;
    procedure   WMEraseBkgnd(var Message: TLMEraseBkgnd); message LM_ERASEBKGND;
  public
    { public declarations }
    constructor Create(TheOwner: TComponent); override;
    destructor  Destroy; override;
  end;

implementation

//##############################################################################

//##############################################################################

//##############################################################################

constructor TExTabSheet.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
end;

destructor TExTabSheet.Destroy;
begin
  inherited Destroy;
end;

procedure TExTabSheet.WMEraseBkgnd(var Message: TLMEraseBkgnd);
begin
  Message.Result:=1;
end;

procedure TExTabSheet.WMPaint(var Msg: TLMPaint);
var
  PS         : TPaintStruct;
  HB         : HBRUSH;
begin
  try
    BeginPaint(Handle, PS);
    HB:=CreateSolidBrush(clRed);
    SelectObject(Msg.DC,HB);
    FillRect(Msg.DC,Classes.Rect(0,0,Width,Height),HB);
    EndPaint(Handle, PS);
  finally
    DeleteObject(HB);
  end;
end;

//##############################################################################

constructor TExPageControl.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);

end;

destructor TExPageControl.Destroy;
begin

  inherited Destroy;
end;

procedure TExPageControl.WMEraseBkgnd(var Message: TLMEraseBkgnd);
begin
  Message.Result:=1;
end;

procedure TExPageControl.WMPaint(var Msg: TLMPaint);
var
  MemDC      : HDC;
  MemBitmap  : HBITMAP;
  PS         : TPaintStruct;
  lCanvas    : TCanvas;
  R,CR       : TRect;
  i,X,Y      : integer;
  oTop       : integer;
  oBottom    : integer;
  ImgWidth   : integer;
  ImgHeight  : integer;
  ImgTop     : integer;
  Points     : array of TPoint;
  MyBitmap   : Graphics.TBitmap;
  FBorder    : integer;
begin

  //DestroyWindow(FindWindowEx(Handle, 0, UPDOWN_CLASS, nil));

  TabHeight  := 0;
  TabWidth   := 0;
  oTop       := 0;
  oBottom    := 0;
  FBorder    := 4;

  if PageCount>0 then begin
    R := TabRect(ActivePageIndex);
    TabHeight := R.Bottom-R.Top;
    TabWidth  := R.Right-R.Left+ImgWidth;
    case TabPosition of
      tpTop       : oTop :=-TabHeight;
      tpLeft      : ;
      tpBottom    : oBottom := TabHeight;
      tpRight     : ;
    end;
  end;

  Color := clBlue;

  BeginPaint(Handle, PS);

  MemBitmap := CreateCompatibleBitmap(Msg.DC,Width+TabWidth,Height+TabHeight);
  MemDC := CreateCompatibleDC(0);
  SelectObject(MemDC, MemBitmap);

  try

    lCanvas             := TCanvas.Create;
    lCanvas.Handle      := MemDC;
    lCanvas.Font.Assign(Font);

    lCanvas.Brush.Style := bsSolid;
    lCanvas.Brush.Color := Color;
    lCanvas.FillRect(0,0,Width+TabWidth,Height+TabHeight);

    lCanvas.Brush.Color := clGray;
    lCanvas.Pen.Color:=clBlack;

    for i:=PageCount-1 downto 0 do begin
      R := TabRect(i);
      TabHeight := R.Bottom-R.Top;
      TabWidth  := R.Right-R.Left;
      inc(R.Top,TabHeight+FBorder);
      inc(R.Bottom,TabHeight+FBorder);
      inc(R.Left,FBorder);
      inc(R.Right,FBorder);
      lCanvas.Rectangle(R.Left,R.Top,R.Right,R.Bottom);

      lCanvas.TextOut(R.Left+ ((TabWidth - lCanvas.TextWidth(Tabs[i])) div 2) ,R.Top+ (((R.Bottom-R.Top) - lCanvas.TextHeight(Tabs[i])) div 2) ,Tabs[i]);
    end;

    lCanvas.Free;

    BitBlt(Msg.DC,-FBorder,-FBorder+oTop,Width+FBorder,Height+FBorder+oBottom,MemDC,0,0,SRCCOPY);

    EndPaint(Handle, PS);
  finally
    DeleteDC(MemDC);
    DeleteObject(MemBitmap);
    if Images<>NIL then MyBitmap.Free;
  end;
end;

end.

